QCPItemPixmap Class Reference
Author: Emanuel Eichhammer

· · · ·
Public Functions | Public Members | Protected Types | Protected Functions
QCPItemPixmap Class Reference

An arbitrary pixmap. More...

Inheritance diagram for QCPItemPixmap:

## Public Functions
| QCPItemPixmap (QCustomPlot *parentPlot)
QPixmap | pixmap () const
bool | scaled () const
Qt::AspectRatioMode | aspectRatioMode () const
Qt::TransformationMode | transformationMode () const
QPen | pen () const
QPen | selectedPen () const
void | setPixmap (const QPixmap &pixmap)
void | setScaled (bool scaled, Qt::AspectRatioMode aspectRatioMode=Qt::KeepAspectRatio, Qt::TransformationMode transformationMode=Qt::SmoothTransformation)
void | setPen (const QPen &pen)
void | setSelectedPen (const QPen &pen)
virtual double | selectTest (const QPointF &pos, bool onlySelectable, QVariant *details=nullptr) const
Public Functions inherited from QCPAbstractItem
| QCPAbstractItem (QCustomPlot *parentPlot)
bool | clipToAxisRect () const
QCPAxisRect * | clipAxisRect () const
bool | selectable () const
bool | selected () const
void | setClipToAxisRect (bool clip)
void | setClipAxisRect (QCPAxisRect *rect)
Q_SLOT void | setSelectable (bool selectable)
Q_SLOT void | setSelected (bool selected)
QList< QCPItemPosition * > | positions () const
QList< QCPItemAnchor * > | anchors () const
QCPItemPosition * | position (const QString &name) const
QCPItemAnchor * | anchor (const QString &name) const
bool | hasAnchor (const QString &name) const
Public Functions inherited from QCPLayerable
| QCPLayerable (QCustomPlot *plot, QString targetLayer=QString(), QCPLayerable *parentLayerable=nullptr)
bool | visible () const
QCustomPlot * | parentPlot () const
QCPLayerable * | parentLayerable () const
QCPLayer * | layer () const
bool | antialiased () const
void | setVisible (bool on)
Q_SLOT bool | setLayer (QCPLayer *layer)
bool | setLayer (const QString &layerName)
void | setAntialiased (bool enabled)
bool | realVisibility () const

## Public Members
QCPItemPosition *const | topLeft
QCPItemPosition *const | bottomRight
QCPItemAnchor *const | top
QCPItemAnchor *const | topRight
QCPItemAnchor *const | right
QCPItemAnchor *const | bottom
QCPItemAnchor *const | bottomLeft
QCPItemAnchor *const | left

## Protected Types
enum | AnchorIndex

## Protected Functions
virtual void | draw (QCPPainter *painter)
virtual QPointF | anchorPixelPosition (int anchorId) const
void | updateScaledPixmap (QRect finalRect=QRect(), bool flipHorz=false, bool flipVert=false)
QRect | getFinalRect (bool *flippedHorz=nullptr, bool *flippedVert=nullptr) const
QPen | mainPen () const
Protected Functions inherited from QCPAbstractItem
virtual QCP::Interaction | selectionCategory () const
virtual QRect | clipRect () const
virtual void | applyDefaultAntialiasingHint (QCPPainter *painter) const
virtual void | selectEvent (QMouseEvent *event, bool additive, const QVariant &details, bool *selectionStateChanged)
virtual void | deselectEvent (bool *selectionStateChanged)
double | rectDistance (const QRectF &rect, const QPointF &pos, bool filledRect) const
QCPItemPosition * | createPosition (const QString &name)
QCPItemAnchor * | createAnchor (const QString &name, int anchorId)
Protected Functions inherited from QCPLayerable
virtual void | parentPlotInitialized (QCustomPlot *parentPlot)
virtual void | mousePressEvent (QMouseEvent *event, const QVariant &details)
virtual void | mouseMoveEvent (QMouseEvent *event, const QPointF &startPos)
virtual void | mouseReleaseEvent (QMouseEvent *event, const QPointF &startPos)
virtual void | mouseDoubleClickEvent (QMouseEvent *event, const QVariant &details)
virtual void | wheelEvent (QWheelEvent *event)
void | initializeParentPlot (QCustomPlot *parentPlot)
void | setParentLayerable (QCPLayerable *parentLayerable)
bool | moveToLayer (QCPLayer *layer, bool prepend)
void | applyAntialiasingHint (QCPPainter *painter, bool localAntialiased, QCP::AntialiasedElement overrideElement) const

## Additional Inherited Members
Signals inherited from QCPAbstractItem
void | selectionChanged (bool selected)
void | selectableChanged (bool selectable)
Signals inherited from QCPLayerable
void | layerChanged (QCPLayer *newLayer)

## Detailed Description

An arbitrary pixmap.

Pixmap example. Blue dotted circles are anchors, solid blue discs are positions.

It has two positions, topLeft and bottomRight, which define the rectangle the pixmap will be drawn in. Depending on the scale setting (setScaled), the pixmap will be either scaled to fit the rectangle or be drawn aligned to the topLeft position.

If scaling is enabled and topLeft is further to the bottom/right than bottomRight (as shown on the right side of the example image), the pixmap will be flipped in the respective orientations.

## Constructor & Destructor Documentation

## § QCPItemPixmap()

QCPItemPixmap::QCPItemPixmap | ( | QCustomPlot * | parentPlot | ) |
| explicit

Creates a rectangle item and sets default values.

The created item is automatically registered with parentPlot. This QCustomPlot instance takes ownership of the item, so do not delete it manually but use QCustomPlot::removeItem() instead.

## Member Function Documentation

## § setPixmap()

void QCPItemPixmap::setPixmap | ( | const QPixmap & | pixmap | ) |

Sets the pixmap that will be displayed.

## § setScaled()

void QCPItemPixmap::setScaled | ( | bool | scaled,
|  | Qt::AspectRatioMode | aspectRatioMode = `Qt::KeepAspectRatio`,
|  | Qt::TransformationMode | transformationMode = `Qt::SmoothTransformation`
| ) |  |

Sets whether the pixmap will be scaled to fit the rectangle defined by the topLeft and bottomRight positions.

## § setPen()

void QCPItemPixmap::setPen | ( | const QPen & | pen | ) |

Sets the pen that will be used to draw a border around the pixmap.

See also
  setSelectedPen, setBrush

## § setSelectedPen()

void QCPItemPixmap::setSelectedPen | ( | const QPen & | pen | ) |

Sets the pen that will be used to draw a border around the pixmap when selected

See also
  setPen, setSelected

## § selectTest()

double QCPItemPixmap::selectTest | ( | const QPointF & | pos,
|  | bool | onlySelectable,
|  | QVariant * | details = `nullptr`
| ) |  | const
| virtual

This function is used to decide whether a click hits a layerable object or not.

pos is a point in pixel coordinates on the QCustomPlot surface. This function returns the shortest pixel distance of this point to the object. If the object is either invisible or the distance couldn't be determined, -1.0 is returned. Further, if onlySelectable is true and the object is not selectable, -1.0 is returned, too.

If the object is represented not by single lines but by an area like a QCPItemText or the bars of a QCPBars plottable, a click inside the area should also be considered a hit. In these cases this function thus returns a constant value greater zero but still below the parent plot's selection tolerance. (typically the selectionTolerance multiplied by 0.99).

Providing a constant value for area objects allows selecting line objects even when they are obscured by such area objects, by clicking close to the lines (i.e. closer than 0.99*selectionTolerance).

The actual setting of the selection state is not done by this function. This is handled by the parent QCustomPlot when the mouseReleaseEvent occurs, and the finally selected object is notified via the selectEvent/deselectEvent methods.

details is an optional output parameter. Every layerable subclass may place any information in details. This information will be passed to selectEvent when the parent QCustomPlot decides on the basis of this selectTest call, that the object was successfully selected. The subsequent call to selectEvent will carry the details. This is useful for multi-part objects (like QCPAxis). This way, a possibly complex calculation to decide which part was clicked is only done once in selectTest. The result (i.e. the actually clicked part) can then be placed in details. So in the subsequent selectEvent, the decision which part was selected doesn't have to be done a second time for a single selection operation.

In the case of 1D Plottables (QCPAbstractPlottable1D, like QCPGraph or QCPBars) details will be set to a QCPDataSelection, describing the closest data point to pos.

You may pass `nullptr` as details to indicate that you are not interested in those selection details.

See also
  selectEvent, deselectEvent, mousePressEvent, wheelEvent, QCustomPlot::setInteractions, QCPAbstractPlottable1D::selectTestRect

Implements QCPAbstractItem.

## § draw()

void QCPItemPixmap::draw | ( | QCPPainter * | painter | ) |
| protectedvirtual

Draws this item with the provided painter.

The cliprect of the provided painter is set to the rect returned by clipRect before this function is called. The clipRect depends on the clipping settings defined by setClipToAxisRect and setClipAxisRect.

Implements QCPAbstractItem.

## § anchorPixelPosition()

QPointF QCPItemPixmap::anchorPixelPosition | ( | int | anchorId | ) | const
| protectedvirtual

Returns the pixel position of the anchor with Id anchorId. This function must be reimplemented in item subclasses if they want to provide anchors (QCPItemAnchor).

For example, if the item has two anchors with id 0 and 1, this function takes one of these anchor ids and returns the respective pixel points of the specified anchor.

See also
  createAnchor

Reimplemented from QCPAbstractItem.

## § updateScaledPixmap()

void QCPItemPixmap::updateScaledPixmap | ( | QRect | finalRect = `QRect()`,
|  | bool | flipHorz = `false`,
|  | bool | flipVert = `false`
| ) |  |
| protected

Creates the buffered scaled image (mScaledPixmap) to fit the specified finalRect. The parameters flipHorz and flipVert control whether the resulting image shall be flipped horizontally or vertically. (This is used when topLeft is further to the bottom/right than bottomRight.)

This function only creates the scaled pixmap when the buffered pixmap has a different size than the expected result, so calling this function repeatedly, e.g. in the draw function, does not cause expensive rescaling every time.

If scaling is disabled, sets mScaledPixmap to a null QPixmap.

## § getFinalRect()

QRect QCPItemPixmap::getFinalRect | ( | bool * | flippedHorz = `nullptr`,
|  | bool * | flippedVert = `nullptr`
| ) |  | const
| protected

Returns the final (tight) rect the pixmap is drawn in, depending on the current item positions and scaling settings.

The output parameters flippedHorz and flippedVert return whether the pixmap should be drawn flipped horizontally or vertically in the returned rect. (The returned rect itself is always normalized, i.e. the top left corner of the rect is actually further to the top/left than the bottom right corner). This is the case when the item position topLeft is further to the bottom/right than bottomRight.

If scaling is disabled, returns a rect with size of the original pixmap and the top left corner aligned with the item position topLeft. The position bottomRight is ignored.

## § mainPen()

QPen QCPItemPixmap::mainPen | ( |  | ) | const
| protected

Returns the pen that should be used for drawing lines. Returns mPen when the item is not selected and mSelectedPen when it is.

The documentation for this class was generated from the following files:

- src/items/item-pixmap.h
- src/items/item-pixmap.cpp